/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include "fxlib.h"
#include "revolution.h"
#include "stdlib.h"


void intToString (int n, char* string);


//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum)
{
    unsigned int key;
	unsigned char *dyna = 0;
	int light, dark, medium;
	unsigned char contrast, state, rePush, rePushAlpha;
	int checksum, factor;
	char string[15];
	unsigned char light_buffer[1024] = {0}, dark_buffer[1024] = {0}, medium_buffer[1024] = {0};

    Bdisp_AllClr_DDVRAM();
	RTCStart();
	srand (RTCReadSecond() + RTCReadMinute()*60 + RTCReadHour()*3600);
	
	light = 986;
	medium = 1947;
	dark = 4450;
	checksum = light + dark + medium;
	
	intToString (light, string);
	CoolText(0, 0, FONT_FIVE, string, light_buffer);
	CoolText(0, 0, FONT_FIVE, string, dark_buffer);
	CoolText(0, 0, FONT_FIVE, string, medium_buffer);
	intToString (medium, string);
	CoolText(0, 7, FONT_FIVE, string, light_buffer);
	CoolText(0, 7, FONT_FIVE, string, dark_buffer);
	CoolText(0, 7, FONT_FIVE, string, medium_buffer);
	intToString (dark, string);
	CoolText(0, 14, FONT_FIVE, string, light_buffer);
	CoolText(0, 14, FONT_FIVE, string, dark_buffer);
	CoolText(0, 14, FONT_FIVE, string, medium_buffer);
	
	GrayLinkBuffers3(&light_buffer, &medium_buffer, &dark_buffer);
	GrayInit3(dark, light, medium);
	
	InvertArea (3, 23, 5, 63, light_buffer);
	InvertArea (6, 23, 11, 63, medium_buffer);
	InvertArea (9, 23, 11, 63, light_buffer);
	InvertArea (12, 23, 23, 63, dark_buffer);
	InvertArea (15, 23, 17, 63, light_buffer);
	InvertArea (18, 23, 23, 63, medium_buffer);
	InvertArea (21, 23, 23, 63, light_buffer);
	
	rePush = 1;
	contrast = 127;
	state = 1;
	rePushAlpha = 1;

    while(IsKeyUp (KEY_CTRL_EXIT)){
		Change_Contrast (contrast);
		if (IsKeyDown(KEY_CTRL_EXE)) {
			dark = rand() % 5500 + 500;
			medium =  rand() % (dark - 500) +50;
			do {
				light = rand() % (dark - medium);
				} while (light >= medium);
		}
		if (IsKeyDown(KEY_CTRL_SHIFT)) factor = 100;
		else if (IsKeyDown(KEY_CTRL_OPTN)) factor = 1000;
		else factor = 1;
		if (IsKeyDown(KEY_CTRL_F1)) light += factor;
		if (IsKeyDown(KEY_CTRL_F2)) light -= factor;
		if (IsKeyDown(KEY_CTRL_F3)) medium += factor;
		if (IsKeyDown(KEY_CTRL_F4)) medium -= factor;
		if (IsKeyDown(KEY_CTRL_F5)) dark += factor;
		if (IsKeyDown(KEY_CTRL_F6)) dark -= factor;
		if (checksum != light + dark + medium) {
			GrayLinkBuffers3(&light_buffer, &medium_buffer, &dark_buffer);
			GrayInit3(dark, light, medium);
			ClearArea (0, 0, 30, 22, light_buffer);
			ClearArea (0, 0, 30, 22, medium_buffer);
			ClearArea (0, 0, 30, 22, dark_buffer);
			intToString (light, string);
			CoolText(0, 0, FONT_FIVE, string, light_buffer);
			CoolText(0, 0, FONT_FIVE, string, dark_buffer);
			CoolText(0, 0, FONT_FIVE, string, medium_buffer);
			intToString (medium, string);
			CoolText(0, 7, FONT_FIVE, string, light_buffer);
			CoolText(0, 7, FONT_FIVE, string, dark_buffer);
			CoolText(0, 7, FONT_FIVE, string, medium_buffer);
			intToString (dark, string);
			CoolText(0, 14, FONT_FIVE, string, light_buffer);
			CoolText(0, 14, FONT_FIVE, string, dark_buffer);
			CoolText(0, 14, FONT_FIVE, string, medium_buffer);
			checksum = light + dark + medium;
		}
		if (IsKeyDown(KEY_CTRL_UP) && rePush) {
			contrast++;
			rePush = 0;
			}
		if (IsKeyDown(KEY_CTRL_DOWN) && rePush) {
			contrast--;
			rePush = 0;
			}
		if (IsKeyUp(KEY_CTRL_DOWN) && IsKeyUp(KEY_CTRL_UP)) rePush = 1;
		
		if (IsKeyDown(KEY_CTRL_ALPHA) && state == 1 && rePushAlpha == 1) {
			GrayEnd();
			state = 0;
			rePushAlpha = 0;
		}
		if (IsKeyDown(KEY_CTRL_ALPHA) && state == 0 && rePushAlpha == 1) {
			GrayLinkBuffers3(&light_buffer, &medium_buffer, &dark_buffer);
			GrayInit3(dark, light, medium);
			state = 1;
			rePushAlpha = 0;
		}
		if (IsKeyUp(KEY_CTRL_ALPHA)) rePushAlpha = 1;
    }
	
	CPUSpeedNormal();
    Reset_Calc();
	return 1;
}




void intToString (int n, char* string) {
	int  i;
	int  cpt;
  
	for (i = 1, cpt = 1; n / i >= 10; i *= 10, cpt++);
	for (cpt = 0; i; cpt++, i /= 10) string[cpt] = (n / i) % 10 + '0';
	string[cpt] = '\0';
}


//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

